Package: EuclideanSD
Type: Package
Title: An Euclidean View of Center and Spread
Version: 0.1.0
Authors@R: c(person(given = "Rishav",
                   family = "Bhattacharjee",
                   role = c("aut"),
                   email = "b.rishav@live.com"),
            person(given = "Siddhanta",
                   family = "Phuyal",
                   role = c("aut","cre"),
                   email = "siddhantaphuyal7159@gmail.com"),
            person(given = "Mamunur",
                   family = "Rashid",
                   role = "aut",
                   email = "mrashid@depauw.edu"),
            person(given = "Jyotirmoy",
                   family = "Sarkar",
                   role = "aut",
                   email = "jsarkar@iupui.edu"))
Maintainer: Siddhanta Phuyal <siddhantaphuyal7159@gmail.com>
Description: Illustrates the concepts developed in Sarkar and Rashid (2019, ISSN:0025-5742) <http://www.google.com/url?sa=t&rct=j&q=&esrc=s&source=web&cd=&cad=rja&uact=8&ved=2ahUKEwiH4deL3q3xAhWX73MBHR_wDaYQFnoECAUQAw&url=https%3A%2F%2Fwww.indianmathsociety.org.in%2Fmathstudent-part-2-2019.pdf&usg=AOvVaw3SY--3T6UAWUnH5-Nj6bSc>.
  This package helps a user guess four things (mean, MD, scaled MSD, and RMSD) before they get the SD. 
    1) The package displays the Empirical Cumulative Distribution Function (ECDF) of
  the given data. The user must choose the value of the mean by equating the areas of 
  two colored (blue and green) regions. The package gives feedback to improve the choice
  until it is correct. Alternatively, the reader may continue with a different guess for 
  the center (not necessarily the mean).
    2) The user chooses the values of the Mean Deviation (MD) based on the ECDF of the deviations
  by equating the areas of two newly colored (blue and green) regions, with feedback from the 
  package until the user guesses correctly.
    3) The user chooses the Scaled Mean Squared Deviation (MSD) based on the ECDF of the scaled 
  square deviations by equating the areas of two newly colored (blue and green) regions, with 
  feedback from the package until the user guesses correctly.
    4) The user chooses the Root Mean Squared Deviation (RMSD) by ensuring that its intersection 
  with the ECDF of the deviations is at the same height as the intersection between the scaled 
  MSD and the ECDF of the scaled squared deviations. Additionally, the intersection of two
  blue lines (the green dot) should fall on the vertical line at the maximum deviation. 
    5) Finally, if the mean is chosen correctly, only then the user can view the population 
  SD (the same as the RMSD) and the sample SD (sqrt(n/(n-1))*RMSD) by clicking the respective 
  buttons. If the mean is chosen incorrectly, the user is asked to correct it. 
License: GPL-3
Encoding: UTF-8
RoxygenNote: 7.1.1
Imports: shiny
NeedsCompilation: no
Packaged: 2021-06-24 16:21:03 UTC; user
Author: Rishav Bhattacharjee [aut],
  Siddhanta Phuyal [aut, cre],
  Mamunur Rashid [aut],
  Jyotirmoy Sarkar [aut]
Repository: CRAN
Date/Publication: 2021-07-01 06:50:02 UTC
Built: R 4.6.0; ; 2026-04-26 12:57:44 UTC; unix

vals <- seq(0, maxDev, length = 10000)
dat <- data.frame(x = vals)
dat$xtrans <- (dat$x)^2/maxDev

static_line <- function(x) {
    return ( (1 / maxDev) * x )
}

correct_y <- 0

observe({
    if (correctMean()) {
        meanGuess <- mean
    } else {
        meanGuess <- input$meanSlider
    }
})
max_val <- max(c(meanGuess + (meanGuess - absmin + 0.001), absmax)) # x value of meanGuess + maxDeviation
maxDev <- max - meanGuess + 0.001 # the maximum deviation

deviation_df <- data.frame(dev = abs(df$values - meanGuess))
deviation_df$scaled_dev <- deviation_df$dev^2 / maxDev

limit <- sd(deviation_df$dev) / 10

rmsd_precise <- sqrt(mean(deviation_df$dev^2))
correct_y <- mdFunc(rmsd_precise, meanGuess)

lower_x <- fullSMSD()
lower_y <- static_line(lower_x)

upper_x <- fullRMSD()
upper_y <- static_line(upper_x)

moving_line_inv <- function(y) {
    return ( (upper_x / lower_y) * y )
}

p <- p + labs(
    title = paste("ECDF of D (n =", n, ")"),
    x = "Deviation",
    y = ""
)

p <- p + geom_hline( # horizontal mapping line
    yintercept = correct_y,
    color = 'red',
    linetype = 'dashed'
)

p <- p + geom_vline( # 0 line
    xintercept = 0,
    color = 'red',
    # linetype = 'dashed'
)

p <- p + geom_vline( # MD line
    xintercept = fullMD(),
    color = 'black',
    linetype = 'dotted'
)

p <- p + geom_vline( # static value
    xintercept = fullSMSD(),
    color = 'red',
    linetype = 'solid'
)

p <- p + geom_vline( # input
    xintercept = fullRMSD(),
    color = 'red',
    linetype = 'solid'
)

p <- p + geom_vline(
    xintercept = maxDev,
    color = 'black',
    # linetype = 'dashed'
)

p <- p + geom_text(
    aes(
        label = "R",
        x = maxDev,
        y = 0
    ),
    nudge_x = 0.005 * maxDev,
    nudge_y = -0.04
)

p <- p + geom_line( # scaled deviations
    data = dat,
    aes(y = mdFunc(x, meanGuess), x = xtrans),
    color = 'black',
    na.rm = TRUE,
    linetype = 'solid'
)

p <- p + geom_line( # unscaled deviations
    data = dat,
    aes(x = x, y = mdFunc(x, meanGuess)),
    na.rm = TRUE,
    color = 'black',
    alpha = 0.6,
    linetype = 'dashed'
)

# Line from (0,0) to (R,0) (static_line)
p <- p + geom_abline(
    slope = 1 / maxDev,
    intercept = 0,
    color = 'blue',
    linetype = 'dashed'
)

# Intersection between static_line and SMSD slider
p <- p + geom_point(
    x = lower_x,
    y = lower_y,
    size = 3
)

# Lower horizontal line
p <- p + geom_hline(
    yintercept = lower_y,
    color = 'blue',
    linetype = 'dashed'
)

# Upper horizontal line
p <- p + geom_hline(
    yintercept = upper_y,
    color = 'blue',
    linetype = 'dashed'
)

# Intersection between static_line and RMSD slider
p <- p + geom_point(
    x = upper_x,
    y = upper_y,
    size = 2
)

# Line from (0,0) to (upper_x, lower_y) (moving line)
p <- p + geom_abline(
    slope = lower_y / upper_x,
    intercept = 0,
    color = 'blue',
    linetype = 'dashed'
)

# Intersection between lower horizontal line and moving line
p <- p + geom_point(
    x = upper_x,
    y = lower_y,
    size = 2
)

# Intersection between upper horizontal line and moving line
p <- p + geom_point(
    x = moving_line_inv(upper_y),
    y = upper_y,
    size = 3,
    color = '#00C400' # darker green (196)
)

mid <- meanGuess
seq1 <- data.frame(x = seq(absmin, mid, length = 5000))
seq2 <- data.frame(x = seq(mid, absmax, length = 5000))

p <- p + geom_line( # ecdf plot
    data = data.frame(x = seq(absmin - 0.001, absmax, length=10000)),
    na.rm = TRUE,
    aes(x = x, y = func(x)),
    color = 'black'
)

p <- p + labs( # title and axes labels
    title = paste("ECDF of X (n =", n, ")"),
    x = "X",
    y = ""
)

if (e$initialized) {
    p <- p + geom_vline(
        xintercept = meanGuess,
        color = 'red'
    )
    p <- p + geom_ribbon(
        data = seq1,
        na.rm = TRUE,
        aes(ymin = 0, ymax = func(x), x = x),
        alpha = 0.4,
        fill = 'green'
    )
    p <- p + geom_ribbon(
        data = seq2,
        na.rm = TRUE,
        aes(ymin = func(x), ymax = 1, x = x),
        alpha = 0.4,
        fill = 'blue'
    )
} else {
    e$initialized <- TRUE # used to set value of variable out of scope
}

library(ggplot2)
function(input, output, session) {
  df <- data.frame(values = EuclideanSD::nums)
  n <- nrow(df)
  mean <- mean(df$values)
  median <- median(df$values) # used to verify certain mathematical properties
  # print(paste("Mean: ", mean))
  # print(paste("Median: ", median))
  absmin = min(df$values)
  absmax = max(df$values)


  correctMean <- reactiveVal(FALSE)
  correctSMSD <- reactiveVal(FALSE)
  correctRMSD <- reactiveVal(FALSE)
  correctMD <- reactiveVal(FALSE)

  # These variables store the values with full precision if the guess is correct
  fullMD <- reactiveVal(0)
  fullRMSD <- reactiveVal(0)
  fullSMSD <- reactiveVal(0)

  mode <- reactiveVal("Mean") # Used for initial setting of mode
  e <- new.env()
  e$initialized <- FALSE # Used to indicate whether or not sliders are initialized

  e$popSD <- 0
  e$sampleSD <- 0
  popToggle <- reactiveVal(1)
  sampleToggle <- reactiveVal(1)

  # Initializes sliders with proper values
  updateSliderInput(
    session,
    "meanSlider",
    value = round(absmin, digits=2),
    min = round(absmin, digits=2),
    max = round(absmax, digits=2)
  )

  # Code for plot
  source("server_src/plot.R", local = TRUE)


  # Handles button presses
  source("server_src/button_handling.R", local = TRUE)


  # Lets JS know that slider values are updated
  observeEvent(input$meanSlider, {
    if (input$meanSlider != mean) {
      correctMean(FALSE)
    }
    session$sendCustomMessage("updateSliderVal", input$meanSlider)
    output$adjustGuess <- renderText({""})
  })

  observeEvent(input$mdSlider, {
    if (correctMD()) {
      correctMD(FALSE)
    }
    session$sendCustomMessage("updateMdSliderVal", input$mdSlider)
    output$adjustMD <- renderText({""})
  })

  observeEvent(input$smsdSlider, {
    if (correctSMSD()) {
      correctSMSD(FALSE)
    }
    updateSliderInput(
      session,
      inputId = "rmsdSlider",
      value = 0,
    )
    session$sendCustomMessage("updateSmsdSliderVal", input$smsdSlider)
    session$sendCustomMessage("correctMD", correctMD())
    output$adjustSMSD <- renderText({""})
  })

  observeEvent(input$rmsdSlider, {
    if (correctRMSD()) {
      correctRMSD(FALSE)
    }
    session$sendCustomMessage("updateRmsdSliderVal", input$rmsdSlider)
    session$sendCustomMessage("correctSMSD", correctSMSD()) # lets max value of slider reappear

    output$adjustRMSD <- renderText({""})
  })


  # Updates max of other sliders based on mean
  observeEvent(input$meanSlider, {
    updateSliderInput(
      session,
      inputId = "mdSlider",
      value = 0,
      max = max(c( (input$meanSlider - round(min(df$values), digits = 3)), round(max(df$values), digits = 3) - input$meanSlider ))
    )
    updateSliderInput(
      session,
      inputId = "smsdSlider",
      value = 0,
      max = max(c( (input$meanSlider - round(min(df$values), digits = 3)), round(max(df$values), digits = 3) - input$meanSlider ))
    )
    updateSliderInput(
      session,
      inputId = "rmsdSlider",
      value = 0,
      max = max(c( (input$meanSlider - round(min(df$values), digits = 3)), round(max(df$values), digits = 3) - input$meanSlider ))
    )
  })


  # Updates sliders from arrow keys
  observeEvent(input$meanSliderNew, {
    updateSliderInput(session, "meanSlider", value = input$meanSliderNew)
    updateSliderInput(session, "mdSlider", value = 0)
    updateSliderInput(session, "smsdSlider", value = 0)
  })

  observeEvent(input$mdSliderNew, {
    updateSliderInput(session, "mdSlider", value = input$mdSliderNew)
  })

  observeEvent(input$smsdSliderNew, {
    updateSliderInput(session, "smsdSlider", value = input$smsdSliderNew)
  })

  observeEvent(input$rmsdSliderNew, {
    updateSliderInput(session, "rmsdSlider", value = input$rmsdSliderNew)
  })


  # Handles changes in radio buttons
  observeEvent(input$mode, {
    mode(input$mode) # updates reactive mode variable
  })

  observe( # sends JS the change in radio button
    session$sendCustomMessage("updateMode", mode())
  )


  # Handles clicking of SD toggles
  observeEvent(input$popSDToggle, {
    popToggle((popToggle() + 1) %% 2)
  })

  observeEvent(input$sampleSDToggle, {
    sampleToggle((sampleToggle() + 1) %% 2)
  })


  # Lets JS know if the guessed mean is correct
  observeEvent({
    correctMean()
    correctSMSD()
    correctRMSD()
    correctMD()
  }, {
    session$sendCustomMessage("correctSMSD", correctSMSD())
    session$sendCustomMessage("correctGuess", ((correctMean() & correctRMSD()) & correctMD()))
    session$sendCustomMessage("correctMD", correctMD())
  })

}

tags$div(class="grid",
    tags$div(class="radioCol",
        tags$input(
            type="radio", id="mdRadio", name="Guess",
            onclick="handleRadio(this)", value="MD", tags$label(class = "radioTxt", "Mean Deviation", tags$br(), "(Uncompressed Dev.)")
        )
    ),
    tags$div(class="sliderCol",
        sliderInput(
            inputId = "mdSlider",
            label = "",
            ticks = FALSE,
            round = -2,
            width = '100%',
            value = 0, min = 0, max = 0,
            step = 0.01
        )
    ),
    tags$div(class="buttonCol",
        actionButton(
            inputId = "mdBtn",
            label = "Submit"
        )
    ),
    tags$div(class="feedbackCol",
        textOutput(outputId = "adjustMD")
    ),
    tags$div(class="checkboxCol",
        checkboxInput(
            inputId = "toggleExpand",
            label = "Expand Plot",
            value = FALSE
        ),
        checkboxInput(
            inputId = "toggleSort",
            label = "Sort (Convert to ECDF of D)",
            value = FALSE
        )
    )
)

tags$div(class="grid", id="sdRow",
    tags$div(class="radioCol",
        tags$input(
            type="radio", id="sdRadio", name="Guess",
            onclick="handleRadio(this)", value="SD", tags$label(class = "radioTxt", "SD")
        )
    ),
    tags$div(class="sliderCol"),
    tags$div(class="buttonCol"),
    tags$div(class="feedbackCol"),
    tags$div(class="checkboxCol",
        checkboxInput(
            inputId = "popSDToggle",
            label = "Show Population SD",
            value = FALSE
        ),
        checkboxInput(
            inputId = "sampleSDToggle",
            label = "Show Sample SD",
            value = FALSE
        )
    )
)

# Code for the plot
output$ecdf <- renderPlot({ # curly braces are for code blocks
    # functions
    func <- ecdf(df$values)
    mirroredFunc <- function(x, a) {
        func(-x + 2*a)
    }
    mdFunc <- function(x, a) {
        func(x+a) - mirroredFunc(x+a, a)
    }
        
    if (correctMean()) {
        meanGuess <- mean
    } else {
        meanGuess <- input$meanSlider
    }

    if (!correctRMSD()) {
        fullRMSD(input$rmsdSlider)
    }

    if (!correctSMSD()) {
        fullSMSD(input$smsdSlider)
    }

    if (!correctMD()) {
        fullMD(input$mdSlider)
    }

    # max <- max(c(meanGuess + (meanGuess - absmin + 0.001), absmax)) # x value of meanGuess + maxDeviation
    max <- max(c(meanGuess + (meanGuess - absmin), absmax)) # x value of meanGuess + maxDeviation
    # maxDev <- max - meanGuess + 0.001 # the maximum deviation
    maxDev <- max - meanGuess # the maximum deviation


    p <- ggplot(df, aes(values)) +
        geom_hline(
            yintercept = 0,
            color = 'black'
        ) +
        geom_hline(
            yintercept = 1,
            color = 'black'
        ) +
        scale_x_continuous(
            n.breaks = 20
        ) +
        scale_y_continuous(
            n.break = 10
        )
            
    if (mode() == "Mean") {
        source("server_src/plots/mean.R", local = TRUE)
    } else if (mode() == "MD") {
        source("server_src/plots/md.R", local = TRUE)
    } else if (mode() == "SMSD") {
        source("server_src/plots/smsd.R", local = TRUE)
    } else if (mode() == "RMSD") {
        source("server_src/plots/rmsd.R", local = TRUE)
    } else if (mode() == "SD") {
        source("server_src/plots/sd.R", local = TRUE)
    }
    
    p
    
})

# Handles button presses
observeEvent(input$meanBtn, {
    # limit <- sd(df$values) / 10
    limit <- 0.1
    difference <- input$meanSlider - round(mean, digits = 2)

    output$adjustGuess <- renderText({
        if (isolate(input$meanSlider) < round(mean, digits = 2)) {
            correctMean(FALSE)
            if (abs(difference) <= limit) {
                return ("Move right slightly")
            }
            return("Move right")
        } else if (isolate(input$meanSlider) > round(mean, digits = 2)) {
            correctMean(FALSE)
            if (abs(difference) <= limit) {
                return ("Move left slightly")
            }
            return("Move left")
        } else {
            correctMean(TRUE)
            return(paste("Correct! Mean: ", round(mean,4)))
        }
    })
})

observeEvent(input$mdBtn, {
    if (correctMean()) {
        meanGuess <- mean
    } else {
        meanGuess <- input$meanSlider
    }
    max <- max(c(meanGuess + (meanGuess - absmin + 0.001), absmax)) # x value of meanGuess + maxDeviation
    maxDev <- max - meanGuess + 0.001 # the maximum deviation

    deviation_df <- data.frame(dev = abs(df$values - meanGuess))

    # limit <- sd(deviation_df$dev) / 10
    limit <- 0.1

    md_precise <- sum(deviation_df$dev) / n
    md <- round(md_precise, digits = 2)
    mdGuess <- input$mdSlider
    difference <- mdGuess - md

    # print(md_precise)

    output$adjustMD <- renderText({
        if (mdGuess < round(md, digits = 2)) {
            correctMD(FALSE)
            if (abs(difference) <= limit) {
                return("Move right slightly")
            }
            return("Move right")
        } else if (mdGuess > round(md, digits = 2)) {
            correctMD(FALSE)
            if (abs(difference) <= limit) {
                return("Move left slightly")
            }
            return("Move left")
        } else {
            correctMD(TRUE)
            fullMD(md_precise)
            return(paste("Correct! MD: ", round(fullMD(), 4)))
        }
    })
})

observeEvent(input$smsdBtn, {
    if (correctMean()) {
        meanGuess <- mean
    } else {
        meanGuess <- input$meanSlider
    }
    max <- max(c(meanGuess + (meanGuess - absmin + 0.001), absmax)) # x value of meanGuess + maxDeviation
    maxDev <- max - meanGuess + 0.001 # the maximum deviation

    deviation_df <- data.frame(dev = abs(df$values - meanGuess))
    deviation_df$scaled_dev <- deviation_df$dev^2 / maxDev

    # limit <- sd(deviation_df$scaled_dev) / 10
    limit <- 0.1

    rmsd <- sqrt(mean(deviation_df$dev^2))

    smsdGuess <- input$smsdSlider
    smsd_precise <- (rmsd^2 / maxDev)
    smsd <- round(smsd_precise, digits = 2)
    # print(smsd_precise)
    difference <- smsdGuess - smsd

    output$adjustSMSD <- renderText({
        if (smsdGuess < smsd) {
            correctSMSD(FALSE)
            if (abs(difference) <= limit) {
                return ("Move right slightly")
            }
            return("Move right")
        } else if (smsdGuess > smsd) {
            correctSMSD(FALSE)
            if (abs(difference) <= limit) {
                return("Move left slightly")
            }
            return("Move left")
        } else {
            correctSMSD(TRUE)
            fullSMSD(smsd_precise)
            return(paste("Correct! SMSD: ", round(fullSMSD(), 4)))
        }
    })
})

observeEvent(input$rmsdBtn, {
    if (correctMean()) {
        meanGuess <- mean
    } else {
        meanGuess <- input$meanSlider
    }
    max <- max(c(meanGuess + (meanGuess - absmin + 0.001), absmax)) # x value of meanGuess + maxDeviation
    maxDev <- max - meanGuess + 0.001 # the maximum deviation

    deviation_df <- data.frame(dev = abs(df$values - meanGuess))
    deviation_df$scaled_dev <- deviation_df$dev^2 / maxDev

    # limit <- sd(deviation_df$dev) / 10
    limit <- 0.1

    rmsd_precise <- sqrt(mean(deviation_df$dev^2))
    rmsd <- round(rmsd_precise, digits = 2)
    rmsdGuess <- input$rmsdSlider
    difference <- rmsdGuess - rmsd

    # print(rmsd_precise)

    output$adjustRMSD <- renderText({
        if (rmsdGuess < rmsd) {
            correctRMSD(FALSE)
            if (abs(difference) <= limit) {
                return ("Move right slightly")
            }
            return("Move right")
        } else if (rmsdGuess > rmsd) {
            correctRMSD(FALSE)
            if (abs(difference) <= limit) {
                return("Move left slightly")
            }
            return("Move left")
        } else {
            correctRMSD(TRUE)
            fullRMSD(rmsd_precise)
            if (!correctMean()) {
                return("Correct!  To find the SD, first guess the mean correctly!")
            } else {
                return(paste("Correct! RMSD: ", round(fullRMSD(), 4)))
            }
        }
    })
})

seq1 <- data.frame(x = seq(meanGuess, fullMD() + meanGuess, length = 5000))
seq2 <- data.frame(x = seq(fullMD() + meanGuess, max, length = 5000))
dat <- data.frame(x = seq(0, max - meanGuess, length = 10000))
dat$xtrans <- (dat$x)^2/maxDev

if (input$toggleSort) { # ecdf of deviations
    p <- p + labs(
        title = paste("ECDF of D (n =", n, ")"),
        x = "Deviation (D)",
        y = ""
    )
    
    p <- p + geom_line( # uncompressed deviations
        data = dat,
        na.rm = TRUE,
        aes(x = x, y = mdFunc(x, meanGuess)),
        color = 'black'
    )

    # p <- p + geom_line( # compressed deviations
    #     data = dat,
    #     na.rm = TRUE,
    #     aes(x = xtrans, y = mdFunc(x, meanGuess)),
    #     color = 'black',
    #     linetype = 'dotted'
    # )
    
    p <- p + geom_vline( # 0 line
        xintercept = 0,
        color = 'red',
        # linetype = 'dashed'
    )
    
    p <- p + geom_vline(
        xintercept = fullMD(),
        color = 'red'
    )

    p <- p + geom_vline(
        xintercept = maxDev,
        color = 'black',
        linetype = 'dashed'
    )

    p <- p + geom_text(
        aes(
            label = "R",
            x = maxDev,
            y = 0
        ),
        nudge_x = 0.005 * maxDev,
        nudge_y = -0.04
    )
    
    p <- p + geom_ribbon(
        data = data.frame(x = seq(0, fullMD(), length=5000)),
        aes(ymin = 0, ymax = mdFunc(x, meanGuess), x = x),
        alpha = 0.4,
        fill = 'green'
    )

    p <- p + geom_ribbon(
        data = data.frame(x = seq(fullMD(), max - meanGuess, length=5000)),
        aes(ymax = 1, ymin = mdFunc(x, meanGuess), x = x),
        alpha = 0.4,
        fill = 'blue'
    )
} else if (!input$toggleExpand) { # full plot
    p <- p + labs(
        title = paste("Mirrored ECDF of X (n =", n, ")"),
        x = "X",
        y = ""
    )
    
    p <- p + geom_vline( # 0 line
        xintercept = meanGuess,
        color = 'red',
        # linetype = 'dashed'
    )
    
    p <- p + geom_vline(
        xintercept = fullMD() + meanGuess,
        color = 'red'
    )
    
    p <- p + geom_line(
        data = data.frame(x = seq(absmin - 0.001, absmax, length=10000)),
        na.rm = TRUE,
        aes(x = x, y = func(x)),
        color = 'black'
    )
    
    p <- p + geom_line( # mirrored plot
        data = data.frame(x = seq(meanGuess, max, length = 10000)),
        na.rm = TRUE,
        aes(y = mirroredFunc(x, meanGuess), x = x),
        color = 'black'
    )
    
    p <- p + geom_ribbon(
        data = seq1,
        na.rm = TRUE,
        aes(ymin = mirroredFunc(x, meanGuess), ymax = func(x), x = x),
        alpha = 0.4,
        fill = 'green'
    )
    
    p <- p + geom_ribbon(
        data = seq2,
        na.rm = TRUE,
        aes(ymin = 0, ymax = mirroredFunc(x, meanGuess), x = x),
        alpha = 0.4,
        fill = 'blue'
    )
    
    p <- p + geom_ribbon(
        data = seq2,
        na.rm = TRUE,
        aes(ymin = func(x), ymax = 1, x = x),
        alpha = 0.4,
        fill = 'blue'
    )
} else { # full plot to right of mean guess
    p <- p + labs(
        title = paste("Mirrored ECDF of X (n =", n, ")"),
        x = "X",
        y = ""
    )
    
    p <- p + geom_vline( # 0 line
        xintercept = meanGuess,
        color = 'red',
        # linetype = 'dashed'
    )
    
    p <- p + geom_vline(
        xintercept = fullMD() + meanGuess,
        color = 'red'
    )
    
    p <- p + geom_line( # right portion of ecdf
        data = data.frame(x = seq(meanGuess, absmax, length=10000)),
        na.rm = TRUE,
        aes(x = x, y = func(x)),
        color = 'black'
    )

    p <- p + geom_line( # mirrored plot
        data = data.frame(x = seq(meanGuess, max, length = 10000)),
        na.rm = TRUE,
        aes(y = mirroredFunc(x, meanGuess), x = x),
        color = 'black'
    )
    
    p <- p + geom_ribbon(
        data = seq1,
        na.rm = TRUE,
        aes(ymin = mirroredFunc(x, meanGuess), ymax = func(x), x = x),
        alpha = 0.4,
        fill = 'green'
    )
    
    p <- p + geom_ribbon(
        data = seq2,
        na.rm = TRUE,
        aes(ymin = 0, ymax = mirroredFunc(x, meanGuess), x = x),
        alpha = 0.4,
        fill = 'blue'
    )
    
    p <- p + geom_ribbon(
        data = seq2,
        na.rm = TRUE,
        aes(ymin = func(x), ymax = 1, x = x),
        alpha = 0.4,
        fill = 'blue'
    )
}

vals <- seq(0, maxDev, length = 10000)
dat <- data.frame(x = vals)
dat$xtrans <- (dat$x)^2/maxDev

# Manually calculated population SD to account for rounding since slider for guessing
# mean has precision to 0.01

# This way, the RMSD and Population SD look identical on the graph when the correct
# mean is selected initially

deviation_df <- data.frame(dev = abs(df$values - meanGuess))
deviation_df$sq_dev <- deviation_df$dev^2
deviation_df$scaled_dev <- deviation_df$sq_dev / maxDev
e$popSD <- sqrt(sum(deviation_df$sq_dev) / n)
e$sampleSD <- sqrt(sum(deviation_df$sq_dev) / (n - 1))

# Value of population SD
if(popToggle() == 0) {
    session$sendCustomMessage("hidePopSD", e$popSD)
} else {
    session$sendCustomMessage("showPopSD", e$popSD)
}

# Value of sample SD
if(sampleToggle() == 0) {
    session$sendCustomMessage("hideSampleSD", e$sampleSD)
} else {
    session$sendCustomMessage("showSampleSD", e$sampleSD)
}

p <- p + labs(
    title = paste("ECDF of D (n =", n, ")"),
    x = "Deviation (D)",
    y = ""
)

p <- p + geom_vline( # 0 line
    xintercept = 0,
    color = 'red',
    # linetype = 'dashed'
)

p <- p + geom_vline( # MD line
    xintercept = fullMD(),
    color = 'black',
    linetype = 'dotted'
)

p <- p + geom_vline( # value of SMSD slider
    xintercept = fullSMSD(),
    color = 'black'
)

if (input$popSDToggle) {
    p <- p + geom_vline( # population SD
        xintercept = e$popSD,
        color = '#FF0000' # red
    )
}

if (input$sampleSDToggle) {
    p <- p + geom_vline( # sample SD
        xintercept = e$sampleSD,
        linetype = 'dashed',
        color = '#0000FF' # blue
    )

    # additional lines
    p <- p + geom_abline(
        slope = (1 - (1/n)) / fullSMSD(), # mathematically correct
        intercept = 0,
        color = 'black',
        linetype = "dashed"
    )

    p <- p + geom_vline(
        xintercept = fullSMSD() * n / (n-1),
        color = 'black',
        linetype = 'dashed'
    )

    # point on population SD line
    p <- p + geom_point(
        x = fullSMSD(),
        y = 1 - (1/n),
        # size = 1
    )
}

p <- p + geom_vline(
    xintercept = maxDev,
    color = 'black',
    # linetype = 'dashed'
)

p <- p + geom_text(
    aes(
        label = "R",
        x = maxDev,
        y = 0
    ),
    nudge_x = 0.005 * maxDev,
    nudge_y = -0.04
)

p <- p + geom_line( # scaled deviations
    data = dat,
    na.rm = TRUE,
    aes(y = mdFunc(x, meanGuess), x = xtrans),
    color = 'black',
    # linetype = 'dotted'
)

p <- p + geom_line( # unscaled deviations
    data = dat,
    na.rm = TRUE,
    aes(x = x, y = mdFunc(x, meanGuess)),
    color = 'black',
    linetype = 'dashed'
)

tags$div(class="grid", id="smsdRow",
    tags$div(class="radioCol",
        tags$input(
            type="radio", id="smsdRadio", name="Guess",
            onclick="handleRadio(this)", value="SMSD", tags$label(class = "radioTxt", "Scaled MSD", tags$br(), "(Compressed Dev.)")
        )
    ),
    tags$div(class="sliderCol",
        sliderInput(
            inputId = "smsdSlider",
            label = "",
            ticks = FALSE,
            round = -2,
            width = '100%',
            value = 0, min = 0, max = 0,
            step = 0.01
        )
    ),
    tags$div(class="buttonCol",
        actionButton(
            inputId = "smsdBtn",
            label = "Submit"
        )
    ),
    tags$div(class="feedbackCol",
        textOutput(outputId = "adjustSMSD")
    ),
    tags$div(class="checkboxCol")
)

fluidPage(

  tags$head(
    tags$link(rel = "stylesheet", type = "text/css", href = "stylesheet.css"),
    tags$script(src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"),
    tags$script(src="script.js")
  ),

  titlePanel("Guess the Mean, Mean Deviation (MD), Scaled Mean Squared Deviation (SMSD), and Root Mean Squared Deviation (RMSD)"),
  plotOutput(outputId = "ecdf"),

  tags$p("Note: You can horizontally resize the plot image by dragging from the bottom right corner of the plot."),



  source("ui_src/meanUI.R", local = TRUE)[1],
  source("ui_src/mdUI.R", local = TRUE)[1],
  source("ui_src/smsdUI.R", local = TRUE)[1],
  source("ui_src/rmsdUI.R", local = TRUE)[1],
  source("ui_src/sdUI.R", local = TRUE)[1]

)

vals <- seq(0, maxDev, length = 10000)
dat <- data.frame(x = vals)
dat$xtrans <- (dat$x)^2/maxDev
dat$xtrans[n] <- maxDev

seq1 <- data.frame(x = seq(0, sqrt(fullSMSD() * maxDev), length = 5000))
seq2 <- data.frame(x = seq(sqrt(fullSMSD() * maxDev), maxDev, length = 5000))

p <- p + labs(
    title = bquote("ECDF of" ~ frac(D^2,R) ~ "(n =" ~ .(n) * ")"),
    x = bquote(frac(D^2,R)),
    y = ""
)

p <- p + geom_vline( # 0 line
    xintercept = 0,
    color = 'red',
    # linetype = 'dashed'
)

p <- p + geom_vline( # input
    xintercept = fullSMSD(),
    color = 'red'
)

p <- p + geom_vline( # MD line
    xintercept = fullMD(),
    color = 'black',
    linetype = 'dotted'
)

p <- p + geom_vline(
    xintercept = maxDev,
    color = 'black',
    # linetype = 'dashed'
)

p <- p + geom_text(
    aes(
        label = "R",
        x = maxDev,
        y = 0
    ),
    nudge_x = 0.005 * maxDev,
    nudge_y = -0.04
)

p <- p + geom_line( # scaled deviations
    data = dat,
    aes(y = mdFunc(x, meanGuess), x = xtrans),
    color = 'black',
    na.rm = TRUE
)

p <- p + geom_line( # unscaled deviations
    data = dat,
    aes(x = x, y = mdFunc(x, meanGuess)),
    na.rm = TRUE,
    color = 'black',
    linetype = 'dashed'
)

p <- p + geom_ribbon(
    data = seq1,
    aes(x = x^2/maxDev, ymax = mdFunc(x, meanGuess), ymin = 0),
    fill = 'green',
    alpha = 0.4
)

p <- p + geom_ribbon(
    data = seq2,
    aes(x = x^2/maxDev, ymin = mdFunc(x, meanGuess), ymax = 1),
    fill = 'blue',
    alpha = 0.4
)
